VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clAddRecord"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'=======================
' Purpose of this class :
'   Generates instance of "on the fly" stored procedures that adds a
'   record to any table.
'------------------------
' Methods:
'   Initialize(Conexion as ADODB.Connection, sTabla as string)
'       retuns a collection with one instance of clCommandParameter per
'       field of sTabla
'   AddRecord (Params as Collection)
'       Adds a record to the sTabla given in Initilize
'       The data for the fields must come trough the collection Params
'       This must be the collection returned by Initialize or a similar
'       one.
'----------------------------------------------
'
'

' Example of use :
'   Dim Conexion As ADODB.Connection
'   Dim Params As Collection
'   Dim Inserter as clAddRecord
' ----------------------------- Initialization
'    Set Conexion = New ADODB.Connection
'    Conexion.CursorLocation = adUseClient ' ! Important
'    Conexion.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Proyectos\Pruebas\VB\Velocidad escritura en BBDD\db21.mdb;Persist Security Info=False"
'    Set Inserter = New clProcAlmacenado
'    Set Params = Inserter.Initialize(Conexion, "Table1")
'---------------------------- Add a record
'
'   Params.Item(Field1) = valorxx
'   Params.Item(Field2) = valoryyy
'   ..
'   Params.Item(CampoUltimo) = valor_UL
'
'   Inserter.AddRecord Params
'----------------------------------------------
'
'
Option Explicit
Private Comando As ADODB.Command
Dim Parametros As Collection


Public Function Initialize(Conexion As ADODB.Connection, sTabla As String) As Collection
Dim Tabla As adox.Table
Dim Campo As adox.Column
Dim catalogo As adox.Catalog
Dim sComando As String
Dim sB As String, I As Integer, sC As String

Dim Parametro As clCommandParameter


    
    Set Comando.ActiveConnection = Conexion
    Set catalogo = New adox.Catalog
    Set catalogo.ActiveConnection = Conexion
    Set Tabla = catalogo.Tables.Item(sTabla)
    sB = "INSERT INTO " & sTabla & " ("
        
    I = 1
    For Each Campo In Tabla.Columns
        If Not Campo.Properties("Autoincrement") Then
            sB = sB & Trim(Campo.Name) & ","
            Set Parametro = New clCommandParameter
            Parametro.iTipo = Campo.Type
            Parametro.iName = Format(I, "Param0")
            sC = sC & Parametro.iName & ","
            Parametros.Add Parametro, Campo.Name
            I = I + 1
        End If
    Next
    sB = Mid(sB, 1, Len(sB) - 1) & ") VALUES ("
    sC = Mid(sC, 1, Len(sC) - 1) & ")"
    sB = sB & sC
    Comando.CommandText = sB
    Comando.Prepared = True
    Set Initialize = Parametros
End Function

Public Sub AddRecord(Parametros As Collection)
Dim P As clCommandParameter
    For Each P In Parametros
        Comando(P.iName) = P.iValue
    Next
    Comando.Execute , , adExecuteNoRecords
End Sub
 
Private Sub Class_Initialize()
    Set Comando = New ADODB.Command
    Set Parametros = New Collection
End Sub

Private Sub Class_Terminate()
        Set Comando = Nothing
        Set Parametros = Nothing
End Sub
